#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x34TN1x1x8_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=1, nu=1, ku=8, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 2, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 8
   const int incBm = -32, incBn = 34;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=32; k; k -= 8) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x34TN34x34x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=34, 
 * lda=34, ldb=34, ldc=0, mu=11, nu=1, ku=8, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M/11)*11;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (((Mb) << 5)+((Mb) << 1));
   const double *stN = B + (((Nb) << 5)+((Nb) << 1));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*11*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 342, incAn = -(((Mb) << 5)+((Mb) << 1));
   #define incBk 8
   const int incBm = -32, incBn = 34;
   #define incCm 11
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            for (k=32; k; k -= 8) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[34];
               rA2 = pA0[68];
               rA3 = pA0[102];
               rA4 = pA0[136];
               rA5 = pA0[170];
               rA6 = pA0[204];
               rA7 = pA0[238];
               rA8 = pA0[272];
               rA9 = pA0[306];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[340];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[35];
               rA2 = pA0[69];
               rA3 = pA0[103];
               rA4 = pA0[137];
               rA5 = pA0[171];
               rA6 = pA0[205];
               rA7 = pA0[239];
               rA8 = pA0[273];
               rA9 = pA0[307];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[341];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[36];
               rA2 = pA0[70];
               rA3 = pA0[104];
               rA4 = pA0[138];
               rA5 = pA0[172];
               rA6 = pA0[206];
               rA7 = pA0[240];
               rA8 = pA0[274];
               rA9 = pA0[308];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[342];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[37];
               rA2 = pA0[71];
               rA3 = pA0[105];
               rA4 = pA0[139];
               rA5 = pA0[173];
               rA6 = pA0[207];
               rA7 = pA0[241];
               rA8 = pA0[275];
               rA9 = pA0[309];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[343];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[38];
               rA2 = pA0[72];
               rA3 = pA0[106];
               rA4 = pA0[140];
               rA5 = pA0[174];
               rA6 = pA0[208];
               rA7 = pA0[242];
               rA8 = pA0[276];
               rA9 = pA0[310];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[344];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[39];
               rA2 = pA0[73];
               rA3 = pA0[107];
               rA4 = pA0[141];
               rA5 = pA0[175];
               rA6 = pA0[209];
               rA7 = pA0[243];
               rA8 = pA0[277];
               rA9 = pA0[311];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[345];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[40];
               rA2 = pA0[74];
               rA3 = pA0[108];
               rA4 = pA0[142];
               rA5 = pA0[176];
               rA6 = pA0[210];
               rA7 = pA0[244];
               rA8 = pA0[278];
               rA9 = pA0[312];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[346];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[41];
               rA2 = pA0[75];
               rA3 = pA0[109];
               rA4 = pA0[143];
               rA5 = pA0[177];
               rA6 = pA0[211];
               rA7 = pA0[245];
               rA8 = pA0[279];
               rA9 = pA0[313];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[347];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[34];
            rA2 = pA0[68];
            rA3 = pA0[102];
            rA4 = pA0[136];
            rA5 = pA0[170];
            rA6 = pA0[204];
            rA7 = pA0[238];
            rA8 = pA0[272];
            rA9 = pA0[306];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[340];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[35];
            rA2 = pA0[69];
            rA3 = pA0[103];
            rA4 = pA0[137];
            rA5 = pA0[171];
            rA6 = pA0[205];
            rA7 = pA0[239];
            rA8 = pA0[273];
            rA9 = pA0[307];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[341];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x34TN1x1x8_a1_bX(k, N, 34, alpha, ca + (((Mb) << 5)+((Mb) << 1)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
