#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x39TN1x1x8_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=39, 
 * lda=39, ldb=39, ldc=0, mu=1, nu=1, ku=8, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (39*(Mb));
   const double *stN = B + (39*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 7, incAn = -(39*(Mb));
   #define incBk 8
   const int incBm = -32, incBn = 39;
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=32; k; k -= 8) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += rA0 * rB0;
         rA0 = pA0[6];
         rB0 = pB0[6];
         rC0_0 += rA0 * rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x39TN39x39x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=39, 
 * lda=39, ldb=39, ldc=0, mu=11, nu=1, ku=8, pf=512
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const int Mb = (M/11)*11;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (39*(Mb));
   const double *stN = B + (39*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*11*1)/(M*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 397, incAn = -(39*(Mb));
   #define incBk 8
   const int incBm = -32, incBn = 39;
   #define incCm 11
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            rC5_0 = pC0[5];
            rC5_0 *= rA0;
            rC6_0 = pC0[6];
            rC6_0 *= rA0;
            rC7_0 = pC0[7];
            rC7_0 *= rA0;
            rC8_0 = pC0[8];
            rC8_0 *= rA0;
            rC9_0 = pC0[9];
            rC9_0 *= rA0;
            rC10_0 = pC0[10];
            rC10_0 *= rA0;
            for (k=32; k; k -= 8) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[39];
               rA2 = pA0[78];
               rA3 = pA0[117];
               rA4 = pA0[156];
               rA5 = pA0[195];
               rA6 = pA0[234];
               rA7 = pA0[273];
               rA8 = pA0[312];
               rA9 = pA0[351];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[390];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[40];
               rA2 = pA0[79];
               rA3 = pA0[118];
               rA4 = pA0[157];
               rA5 = pA0[196];
               rA6 = pA0[235];
               rA7 = pA0[274];
               rA8 = pA0[313];
               rA9 = pA0[352];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[391];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[41];
               rA2 = pA0[80];
               rA3 = pA0[119];
               rA4 = pA0[158];
               rA5 = pA0[197];
               rA6 = pA0[236];
               rA7 = pA0[275];
               rA8 = pA0[314];
               rA9 = pA0[353];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[392];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[42];
               rA2 = pA0[81];
               rA3 = pA0[120];
               rA4 = pA0[159];
               rA5 = pA0[198];
               rA6 = pA0[237];
               rA7 = pA0[276];
               rA8 = pA0[315];
               rA9 = pA0[354];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[393];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[43];
               rA2 = pA0[82];
               rA3 = pA0[121];
               rA4 = pA0[160];
               rA5 = pA0[199];
               rA6 = pA0[238];
               rA7 = pA0[277];
               rA8 = pA0[316];
               rA9 = pA0[355];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[394];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[44];
               rA2 = pA0[83];
               rA3 = pA0[122];
               rA4 = pA0[161];
               rA5 = pA0[200];
               rA6 = pA0[239];
               rA7 = pA0[278];
               rA8 = pA0[317];
               rA9 = pA0[356];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[395];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[6];
               rB0 = pB0[6];
               rA1 = pA0[45];
               rA2 = pA0[84];
               rA3 = pA0[123];
               rA4 = pA0[162];
               rA5 = pA0[201];
               rA6 = pA0[240];
               rA7 = pA0[279];
               rA8 = pA0[318];
               rA9 = pA0[357];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[396];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               rA0 = pA0[7];
               rB0 = pB0[7];
               rA1 = pA0[46];
               rA2 = pA0[85];
               rA3 = pA0[124];
               rA4 = pA0[163];
               rA5 = pA0[202];
               rA6 = pA0[241];
               rA7 = pA0[280];
               rA8 = pA0[319];
               rA9 = pA0[358];
               rC0_0 += rA0 * rB0;
               rA10 = pA0[397];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC6_0 += rA6 * rB0;
               rC7_0 += rA7 * rB0;
               rC8_0 += rA8 * rB0;
               rC9_0 += rA9 * rB0;
               rC10_0 += rA10 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[39];
            rA2 = pA0[78];
            rA3 = pA0[117];
            rA4 = pA0[156];
            rA5 = pA0[195];
            rA6 = pA0[234];
            rA7 = pA0[273];
            rA8 = pA0[312];
            rA9 = pA0[351];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[390];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[40];
            rA2 = pA0[79];
            rA3 = pA0[118];
            rA4 = pA0[157];
            rA5 = pA0[196];
            rA6 = pA0[235];
            rA7 = pA0[274];
            rA8 = pA0[313];
            rA9 = pA0[352];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[391];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[41];
            rA2 = pA0[80];
            rA3 = pA0[119];
            rA4 = pA0[158];
            rA5 = pA0[197];
            rA6 = pA0[236];
            rA7 = pA0[275];
            rA8 = pA0[314];
            rA9 = pA0[353];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[392];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[42];
            rA2 = pA0[81];
            rA3 = pA0[120];
            rA4 = pA0[159];
            rA5 = pA0[198];
            rA6 = pA0[237];
            rA7 = pA0[276];
            rA8 = pA0[315];
            rA9 = pA0[354];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[393];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[43];
            rA2 = pA0[82];
            rA3 = pA0[121];
            rA4 = pA0[160];
            rA5 = pA0[199];
            rA6 = pA0[238];
            rA7 = pA0[277];
            rA8 = pA0[316];
            rA9 = pA0[355];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[394];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[44];
            rA2 = pA0[83];
            rA3 = pA0[122];
            rA4 = pA0[161];
            rA5 = pA0[200];
            rA6 = pA0[239];
            rA7 = pA0[278];
            rA8 = pA0[317];
            rA9 = pA0[356];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[395];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[45];
            rA2 = pA0[84];
            rA3 = pA0[123];
            rA4 = pA0[162];
            rA5 = pA0[201];
            rA6 = pA0[240];
            rA7 = pA0[279];
            rA8 = pA0[318];
            rA9 = pA0[357];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[396];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0[5] = rC5_0;
            pC0[6] = rC6_0;
            pC0[7] = rC7_0;
            pC0[8] = rC8_0;
            pC0[9] = rC9_0;
            pC0[10] = rC10_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x39TN1x1x8_a1_bX(k, N, 39, alpha, ca + (39*(Mb)), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
