#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_zJIK44x0x44TN44x44x0_a1_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=44, NB=0, KB=44, 
 * lda=44, ldb=44, ldc=0, mu=11, nu=1, ku=8, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   #define Nb N
   const double *stM = A + 1936;
   const double *stN = B + (44*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*11*1)/(44*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 8
   const int incAm = 444, incAn = -1936;
   #define incBk 8
   const int incBm = -40, incBn = 44;
   #define incCm 22
   const int incCn = (((ldc) << 1)) - 88;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9, rA10;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0, rC10_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
         rC4_0 = pC0[8];
         rC4_0 *= rA0;
         rC5_0 = pC0[10];
         rC5_0 *= rA0;
         rC6_0 = pC0[12];
         rC6_0 *= rA0;
         rC7_0 = pC0[14];
         rC7_0 *= rA0;
         rC8_0 = pC0[16];
         rC8_0 *= rA0;
         rC9_0 = pC0[18];
         rC9_0 *= rA0;
         rC10_0 = pC0[20];
         rC10_0 *= rA0;
         for (k=40; k; k -= 8) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[44];
            rA2 = pA0[88];
            rA3 = pA0[132];
            rA4 = pA0[176];
            rA5 = pA0[220];
            rA6 = pA0[264];
            rA7 = pA0[308];
            rA8 = pA0[352];
            rA9 = pA0[396];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[440];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[45];
            rA2 = pA0[89];
            rA3 = pA0[133];
            rA4 = pA0[177];
            rA5 = pA0[221];
            rA6 = pA0[265];
            rA7 = pA0[309];
            rA8 = pA0[353];
            rA9 = pA0[397];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[441];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[46];
            rA2 = pA0[90];
            rA3 = pA0[134];
            rA4 = pA0[178];
            rA5 = pA0[222];
            rA6 = pA0[266];
            rA7 = pA0[310];
            rA8 = pA0[354];
            rA9 = pA0[398];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[442];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[47];
            rA2 = pA0[91];
            rA3 = pA0[135];
            rA4 = pA0[179];
            rA5 = pA0[223];
            rA6 = pA0[267];
            rA7 = pA0[311];
            rA8 = pA0[355];
            rA9 = pA0[399];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[443];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[48];
            rA2 = pA0[92];
            rA3 = pA0[136];
            rA4 = pA0[180];
            rA5 = pA0[224];
            rA6 = pA0[268];
            rA7 = pA0[312];
            rA8 = pA0[356];
            rA9 = pA0[400];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[444];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[49];
            rA2 = pA0[93];
            rA3 = pA0[137];
            rA4 = pA0[181];
            rA5 = pA0[225];
            rA6 = pA0[269];
            rA7 = pA0[313];
            rA8 = pA0[357];
            rA9 = pA0[401];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[445];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[6];
            rB0 = pB0[6];
            rA1 = pA0[50];
            rA2 = pA0[94];
            rA3 = pA0[138];
            rA4 = pA0[182];
            rA5 = pA0[226];
            rA6 = pA0[270];
            rA7 = pA0[314];
            rA8 = pA0[358];
            rA9 = pA0[402];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[446];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            rA0 = pA0[7];
            rB0 = pB0[7];
            rA1 = pA0[51];
            rA2 = pA0[95];
            rA3 = pA0[139];
            rA4 = pA0[183];
            rA5 = pA0[227];
            rA6 = pA0[271];
            rA7 = pA0[315];
            rA8 = pA0[359];
            rA9 = pA0[403];
            rC0_0 += rA0 * rB0;
            rA10 = pA0[447];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rC10_0 += rA10 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[44];
         rA2 = pA0[88];
         rA3 = pA0[132];
         rA4 = pA0[176];
         rA5 = pA0[220];
         rA6 = pA0[264];
         rA7 = pA0[308];
         rA8 = pA0[352];
         rA9 = pA0[396];
         rC0_0 += rA0 * rB0;
         rA10 = pA0[440];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC8_0 += rA8 * rB0;
         rC9_0 += rA9 * rB0;
         rC10_0 += rA10 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rA1 = pA0[45];
         rA2 = pA0[89];
         rA3 = pA0[133];
         rA4 = pA0[177];
         rA5 = pA0[221];
         rA6 = pA0[265];
         rA7 = pA0[309];
         rA8 = pA0[353];
         rA9 = pA0[397];
         rC0_0 += rA0 * rB0;
         rA10 = pA0[441];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC8_0 += rA8 * rB0;
         rC9_0 += rA9 * rB0;
         rC10_0 += rA10 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rA1 = pA0[46];
         rA2 = pA0[90];
         rA3 = pA0[134];
         rA4 = pA0[178];
         rA5 = pA0[222];
         rA6 = pA0[266];
         rA7 = pA0[310];
         rA8 = pA0[354];
         rA9 = pA0[398];
         rC0_0 += rA0 * rB0;
         rA10 = pA0[442];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC8_0 += rA8 * rB0;
         rC9_0 += rA9 * rB0;
         rC10_0 += rA10 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rA1 = pA0[47];
         rA2 = pA0[91];
         rA3 = pA0[135];
         rA4 = pA0[179];
         rA5 = pA0[223];
         rA6 = pA0[267];
         rA7 = pA0[311];
         rA8 = pA0[355];
         rA9 = pA0[399];
         rC0_0 += rA0 * rB0;
         rA10 = pA0[443];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC8_0 += rA8 * rB0;
         rC9_0 += rA9 * rB0;
         rC10_0 += rA10 * rB0;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0[12] = rC6_0;
         pC0[14] = rC7_0;
         pC0[16] = rC8_0;
         pC0[18] = rC9_0;
         pC0[20] = rC10_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_bX ATL_zgpNBmm_bX
#endif

void ATL_zJIK44x0x44TN44x44x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK44x0x44TN44x44x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK44x0x44TN44x44x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK44x0x44TN44x44x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK44x0x44TN44x44x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK44x0x44TN44x44x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK44x0x44TN44x44x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
